  MEMBER('MarTest.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
MarTest_BC0:DctInit    PROCEDURE()
MarTest_BC0:DctKill    PROCEDURE()
MarTest_BC0:FilesInit  PROCEDURE()
  END

Hide:Access:Makes    CLASS(FileManager),TYPE               ! FileManager for Makes
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Makes    CLASS(RelationManager),TYPE           ! RelationManager for Makes
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Models   CLASS(FileManager),TYPE               ! FileManager for Models
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Models   CLASS(RelationManager),TYPE           ! RelationManager for Models
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Cars     CLASS(FileManager),TYPE               ! FileManager for Cars
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Cars     CLASS(RelationManager),TYPE           ! RelationManager for Cars
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Makes   &Hide:Access:Makes,AUTO,THREAD
_Hide:Relate:Makes   &Hide:Relate:Makes,AUTO,THREAD
_Hide:Access:Models  &Hide:Access:Models,AUTO,THREAD
_Hide:Relate:Models  &Hide:Relate:Models,AUTO,THREAD
_Hide:Access:Cars    &Hide:Access:Cars,AUTO,THREAD
_Hide:Relate:Cars    &Hide:Relate:Cars,AUTO,THREAD


MarTest_BC0:DctInit PROCEDURE()
  CODE
  _Hide:Access:Makes &= NEW(Hide:Access:Makes)
  _Hide:Relate:Makes &= NEW(Hide:Relate:Makes)
  _Hide:Access:Models &= NEW(Hide:Access:Models)
  _Hide:Relate:Models &= NEW(Hide:Relate:Models)
  _Hide:Access:Cars &= NEW(Hide:Access:Cars)
  _Hide:Relate:Cars &= NEW(Hide:Relate:Cars)
  Relate:Makes &= _Hide:Relate:Makes
  Relate:Models &= _Hide:Relate:Models
  Relate:Cars &= _Hide:Relate:Cars


MarTest_BC0:FilesInit PROCEDURE()
  CODE
  _Hide:Relate:Makes.Init
  _Hide:Relate:Models.Init
  _Hide:Relate:Cars.Init


MarTest_BC0:DctKill PROCEDURE()
  CODE
  _Hide:Relate:Makes.Kill
  DISPOSE(_Hide:Relate:Makes)
  _Hide:Relate:Models.Kill
  DISPOSE(_Hide:Relate:Models)
  _Hide:Relate:Cars.Kill
  DISPOSE(_Hide:Relate:Cars)


Hide:Relate:Makes.Init PROCEDURE()
  CODE
  _Hide:Access:Makes.Init
  SELF.Init(Access:Makes,1)


Hide:Access:Makes.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= MAK:Record
  SELF.FileNameValue = 'Makes'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Makes
  PARENT.Init
  Access:Makes &= SELF


Hide:Access:Makes.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Makes &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Makes.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Makes,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(MAK:byId,'MAK:byId',1)
    SELF.AddKey(MAK:byMake,'MAK:byMake',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Makes.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Models,RI:None,RI:None,MOD:byIdMakeFKModel)
  SELF.AddRelationLink(MAK:Make,MOD:IdMakeFK)


Hide:Relate:Makes.Kill PROCEDURE

  CODE
  _Hide:Access:Makes.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:Makes &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Makes)                              ! destroy the file manager


Hide:Relate:Models.Init PROCEDURE()
  CODE
  _Hide:Access:Models.Init
  SELF.Init(Access:Models,1)


Hide:Access:Models.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= MOD:Record
  SELF.FileNameValue = 'Models'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Models
  PARENT.Init
  Access:Models &= SELF


Hide:Access:Models.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Models &= NULL                                    ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Models.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Models,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(MOD:byIdModel,'MOD:byIdModel',1)
    SELF.AddKey(MOD:byIdMakeFKModel,'MOD:byIdMakeFKModel',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Models.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Makes)


Hide:Relate:Models.Kill PROCEDURE

  CODE
  _Hide:Access:Models.Kill                                 ! Kill the file manager
  PARENT.Kill
  Relate:Models &= NULL                                    ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Models)                             ! destroy the file manager


Hide:Relate:Cars.Init PROCEDURE()
  CODE
  _Hide:Access:Cars.Init
  SELF.Init(Access:Cars,1)


Hide:Access:Cars.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= Car:Record
  SELF.FileNameValue = 'Cars'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Cars
  PARENT.Init
  Access:Cars &= SELF


Hide:Access:Cars.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Cars &= NULL                                      ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Cars.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Cars,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(Car:byId,'Car:byId',1)
    SELF.AddKey(Car:ByModel,'Car:ByModel',0)
    SELF.AddKey(Car:byMake,'Car:byMake',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Cars.Kill PROCEDURE

  CODE
  _Hide:Access:Cars.Kill                                   ! Kill the file manager
  PARENT.Kill
  Relate:Cars &= NULL                                      ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Cars)                               ! destroy the file manager

