   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('MARTEST_BC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('MARTEST001.CLW')
Main                   PROCEDURE   !Wizard Application for C:\Applications\C11\MarTest\MarTest.dct
     END
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
Makes                FILE,DRIVER('TOPSPEED'),NAME('Makes.tps'),PRE(MAK),BINDABLE,CREATE,THREAD !                     
byId                     KEY(MAK:Id),NOCASE,OPT,PRIMARY    !                     
byMake                   KEY(MAK:Make),NOCASE,OPT          !                     
Record                   RECORD,PRE()
Id                          LONG                           !                     
Make                        STRING(30)                     !                     
                         END
                     END                       

Models               FILE,DRIVER('TOPSPEED'),NAME('Models.tps'),PRE(MOD),BINDABLE,CREATE,THREAD !                     
byIdModel                KEY(MOD:IdModel),NOCASE,OPT,PRIMARY !                     
byIdMakeFKModel          KEY(MOD:IdMakeFK,MOD:Model),DUP,NOCASE,OPT !                     
Record                   RECORD,PRE()
IdModel                     LONG                           !                     
IdMakeFK                    LONG                           !                     
Model                       STRING(20)                     !                     
                         END
                     END                       

Cars                 FILE,DRIVER('TOPSPEED'),NAME('Cars.tps'),PRE(Car),BINDABLE,CREATE,THREAD !                     
byId                     KEY(Car:Id),NOCASE,OPT,PRIMARY    !                     
ByModel                  KEY(Car:IdModelFK),DUP,NOCASE     !                     
byMake                   KEY(Car:IdMakeFK,Car:IdModelFK),DUP,NOCASE !                     
Record                   RECORD,PRE()
Id                          LONG                           !                     
IdMakeFK                    LONG                           !                     
IdModelFK                   LONG                           !                     
RegNo                       STRING(20)                     !                     
Price                       DECIMAL(7,2)                   !                     
                         END
                     END                       

!endregion

Access:Makes         &FileManager,THREAD                   ! FileManager for Makes
Relate:Makes         &RelationManager,THREAD               ! RelationManager for Makes
Access:Models        &FileManager,THREAD                   ! FileManager for Models
Relate:Models        &RelationManager,THREAD               ! RelationManager for Models
Access:Cars          &FileManager,THREAD                   ! FileManager for Cars
Relate:Cars          &RelationManager,THREAD               ! RelationManager for Cars

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END


  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('.\MarTest.INI', NVD_INI)                    ! Configure INIManager to use INI file
  DctInit()
  Main
  INIMgr.Update
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

